%
% esempio di chiamata:
%
% lagrange(linspace(-5,5,10),@(x)frunge(x),1,1);
%
% calcolo e disegno l'interpolata di Lagrange
% input: la funzione f, i nodi x
%        iplot (se uguale a 0 non faccio il plot)
% output: i valori della funzione e del polinomio interpolante
%         su una mesh molto fitta (determinata da k)
% la funzione f puo' essere data in piu' modi,
% per esempio:
%      1) @(x) frunge(x) (se esiste la function frunge)
%      2) @(x) sin(x)

function [yf yp]=lagrange(x,f,iplot,ifig)
k=100; % numero di punti usati per la ricostruzione del polinomio e della funzione
n=length(x)-1;
a=x(1); b=x(n+1);
y=f(x);
p=polyfit(x,y,n);
xx=linspace(a,b,k);
yf=f(xx);
yp=polyval(p,xx);
%
if iplot~=0
    figure(ifig)
    clf
    set(ifig,'defaultlinelinewidth',3)
    set(ifig,'defaultlinemarkersize',10)
    set(ifig,'defaultaxesfontsize',15)
    plot(xx,yf,xx,yp)
    hold on;
    plot(x,y,'ro')
    title(['n=' num2str(n)],'fontsize',20)
end
